Subject: [Disman] Expression MIB

From: Glenn Mansfield Keeni <[email-masked]>
Date: Thu, 07 Oct 2004 20:48:20 +0900

Hi,
  It seems that the Expression MIB has not found much interest in the
community. I have probably missed the discussion on the demerits of the
MIB.
  Can someone tell me or point me to any discussion about what went wrong
or what is bad about this MIB?
  I personally find the Expression MIB a good and useful piece of work.

   Thanks

   Glenn

---

From: "Randy Presuhn" <[email-masked]>
Date: Thu, 7 Oct 2004 11:07:14 -0700

Hi -

> From: "Glenn Mansfield Keeni" <[email-masked]>
> To: <[email-masked]>
> Sent: Thursday, October 07, 2004 4:48 AM
> Subject: [Disman] Expression MIB
>

>   I personally find the Expression MIB a good and useful piece of work.
...

At this stage, interest is gauged by implementation reports
and discussion.  If you'd like this work to be able to advance,
submitting a report on your implementation would help.
(Please note the attached message from over three months ago!)
When there are no implementation reports, even from groups
that were its biggest proponents and who have probably implemented
it, claims that the MIB module is "good and useful" ring hollow.
RFC 2026 section 4.1.2 is quite clear on what needs to happen before
this work can advance.

Randy
disman WG chair

==================================
Status:  U
From: "Randy Presuhn" <[email-masked]>
To: "Disman \(E-mail\)" <[email-masked]>
Subject: Re: [Disman] Expression MIB Implementation Survey
Date: Tue, 15 Jun 2004 13:57:20 -0700
Sender: [email-masked]

Hi -

Two months have passed, and I haven't seen a single response.
Suggestions?

Randy

> From: "Randy Presuhn" <[email-masked]>
> To: "Disman (E-mail)" <[email-masked]>
> Sent: Monday, April 05, 2004 12:30 PM
> Subject: [Disman] Expression MIB Implementation Survey
>

> Hi -
>
> Here is the Implementation Survey for RFC 2982, the Expression MIB.
> Please send responses to [email-masked] , or, if you would like your implementation
> to remain anonymous for the implementation report, to the WG chair at
> [email-masked].
>
> =================================================
>
> Implementat Survey for RFC 2982,
> Distributed Management Expression MIB
>
>
> Implementation Source:
> Management Application / Agent:
> Module: DISMAN-EXPRESSION-MIB
>
> GROUPs:
> dismanExpressionResourceGroup (y/n): _
> dismanExpressionDefinitionGroup (y/n): _
> dismanExpressionValueGroup (y,n): _
>
> OBJECTs:
> expResourceDeltaMinimum full range supported (y/n): _
> expObjectSampleType deltas supported (y/n): _
> expObjectIDWildcard wildcard supported (y/n): _
> expObjectDiscontinuityIDWildcard wildcard supported (y/n): _
> expObjectConditionalWildcard deltas/wildcards supported (y/n): _
>
>
> Deployment / Operational Experience:
>
>
> Comments:
>
>
>

---

From: Glenn Mansfield Keeni <[email-masked]>
Date: Mon, 18 Oct 2004 14:37:00 +0900

Hi,
  The following is the Expression MIB implementation experience at
Cyber Solutions.

   Glenn

>>Implementation Source:          Cyber Solutions Inc. 
>>Management Application / Agent: Application and Agent
>>dismanExpressionResourceGroup (y/n): n
>>dismanExpressionDefinitionGroup (y/n): y
>>dismanExpressionValueGroup (y,n): y
>>
>>OBJECTs:
>>expResourceDeltaMinimum full range supported (y/n): n
>>expObjectSampleType deltas supported (y/n): y
>>expObjectIDWildcard wildcard supported (y/n): n
>>expObjectDiscontinuityIDWildcard wildcard supported (y/n): n
>>expObjectConditionalWildcard deltas/wildcards supported (y/n): n
>>
>>
  The DISMAN-EXPRESSION-MIB is deployed on our passive sensors
  (CpMonitor). There is generic proprietary MIB (CpMonitorMIB)
  that is supported on these sensors that covers a very wide
  range of protocol based statistics,
     [VLAN, IP,MAC] wise,
        [IPv4,IPv6,Other] stats,
        [UDP,TCP.ICMP,Other] stats
        [Port] stats
  Three type of stats are served - the Min, Max and Average. The
  Max is taken by considering the deltas of the statistic over a
  small interval (msecs) in the polling window.

  That is a rich source of information but sending it all to the
  manager does ot make sense and is bandwidth/resource expensive.
  We use the DISMAN-EXPRESSION-MIB to build higher level
  information objects to cater to the needs of the Network Manager.

  We have a generic Management Application (ApMan) module of our
  network management platform (NetSkate Visualizer) that has a
  simple GUI that interfaces with the agent and allows a user to
  generate the expressions for the higher level information objects.
  The Network Manager uses these higher information objects for simple
  matters like statistics generation, resource management, fault
  detection, and security management.

  We have also built an aggregation mechanism which may be considered
  as an extension of the DISMAN-EXPRESSION-MIB. It basically allows the
  concatenation of MO instance values. This has proven to be very
  effective in routine polling of a large number of MOs. This cuts
  down the overhead of OIDs in the SNMP 'get' and 'response' PDUs.

  Computer resource consumption due to delta's is not a major
  concern on these sensors.

  The net-snmp code base is used for the implementation.
>>Comments:
 1. The MIB is nicely done - but there are places that need more
    clarity. Particularly the definitions of the operators and
    operations.
 2. The wild-carding provides great power but its implementation
    was found to be complex.
 3. I would recommend the addition of the MO-instance value
    concatenation operator. It has immediate and wide-spread
    application.

---

From: Glenn Mansfield Keeni <[email-masked]>
Date: Mon, 18 Oct 2004 14:39:48 +0900

Hi,
   I have just filled up and sent the details of our partial
implementation of the DISMAN-EXPRESSION-MIB.
   Are there any  pointers to discussion on the pros and cons
of the DISMAN-EXPRESSION-MIB ?

   Glenn

> Return-Path: <[email-masked]>
> Received: from megatron.ietf.org ([132.151.6.71])
>  by james.mail.atl.earthlink.net (EarthLink SMTP Server) with ESMTP id 1bAsxS7yG3Nl3r10
>  Wed, 16 Jun 2004 01:01:08 -0400 (EDT)
> Received: from localhost.localdomain ([127.0.0.1] helo=megatron.ietf.org)
>  by megatron.ietf.org with esmtp (Exim 4.32)
>  id 1BaSK8-0007kV-Va; Wed, 16 Jun 2004 00:46:56 -0400
> Received: from odin.ietf.org ([132.151.1.176] helo=ietf.org)
>  by megatron.ietf.org with esmtp (Exim 4.32) id 1BaS9J-0004II-LH
>  for [email-masked]; Wed, 16 Jun 2004 00:35:45 -0400
> Received: from ietf-mx (ietf-mx.ietf.org [132.151.6.1])
>  by ietf.org (8.9.1a/8.9.1a) with ESMTP id AAA14732
>  for <[email-masked]>; Wed, 16 Jun 2004 00:35:42 -0400 (EDT)
> Received: from ietf-mx.ietf.org ([132.151.6.1] helo=ietf-mx)
>  by ietf-mx with esmtp (Exim 4.32) id 1BaS9H-00063M-GV
>  for [email-masked]; Wed, 16 Jun 2004 00:35:43 -0400
> Received: from exim by ietf-mx with spam-scanned (Exim 4.12)
>  id 1BaNPW-0007Pk-00
>  for [email-masked]; Tue, 15 Jun 2004 19:32:12 -0400
> Received: from flamingo.mail.pas.earthlink.net ([207.217.120.232])
>  by ietf-mx with esmtp (Exim 4.12) id 1BaKym-0003js-00
>  for [email-masked]; Tue, 15 Jun 2004 16:56:24 -0400
> Received: from h-68-164-78-145.snvacaid.dynamic.covad.net ([68.164.78.145]
>  helo=oemcomputer)
>  by flamingo.mail.pas.earthlink.net with smtp (Exim 3.33 #1)
>  id 1BaKym-0000XQ-00
>  for [email-masked]; Tue, 15 Jun 2004 13:56:25 -0700
> Message-ID: <007d01c4531b$5a4043c0$7f1afea9@oemcomputer>
> References: <00c201c41b44$6d116880$7f1afea9@oemcomputer>
> X-Priority: 3
> X-MSMail-Priority: Normal
> X-Mailer: Microsoft Outlook Express 6.00.2800.1409
> X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2800.1409
> X-Spam-Checker-Version: SpamAssassin 2.60 (1.212-2003-09-23-exp) on
>  ietf-mx.ietf.org
> X-Spam-Status: No, hits=0.0 required=5.0 tests=AWL autolearn=no version=2.60
> X-BeenThere: [email-masked]
> X-Mailman-Version: 2.1.5
> Precedence: list
> List-Id: Distributed Management <disman.ietf.org>
> List-Unsubscribe: <https://www1.ietf.org/mailman/listinfo/disman>,
>  <mailto:[email-masked]?subject=unsubscribe>
> List-Archive: <http://www1.ietf.org/pipermail/disman>
> List-Post: <mailto:[email-masked]>
> List-Help: <mailto:[email-masked]?subject=help>
> List-Subscribe: <https://www1.ietf.org/mailman/listinfo/disman>,
>  <mailto:[email-masked]?subject=subscribe>
> Errors-To: [email-masked]
> X-ELNK-AV: 0
> 
> Hi -
>

---

From: "Randy Presuhn" <[email-masked]>
Date: Thu, 21 Oct 2004 15:22:38 -0700

Hi -

It's good to finally see an implementation report for this.
A couple of questions in-line below...

> To: "Randy Presuhn" <[email-masked]>
> Cc: <[email-masked]>
> Sent: Sunday, October 17, 2004 10:37 PM
> Subject: Re: [Disman] Expression MIB
...
> >>dismanExpressionResourceGroup (y/n): n

This is currently a mandatory group.  *If* we were to update
the specification, what would you like the conformance material
to look like?

...
> >>expResourceDeltaMinimum full range supported (y/n): n

What is the subset of values that was useful, or was this just
not implemented at all?

...
...
...

Would you care to comment further on wildcarding?  Was it not
implemented at all or was it just implemented in limited form?

Randy

P.S.  I cc'ed Glenn because he's not a mailing list subscriber, at least
at that address.

---

From: "Randy Presuhn" <[email-masked]>
Date: Thu, 21 Oct 2004 15:41:49 -0700

Hi -

> To: "Randy Presuhn" <[email-masked]>; <[email-masked]>
> Sent: Sunday, October 17, 2004 10:39 PM
...
...

The split between script and expression is old.  See the minutes at
http://www.ietf.org/ietf/disman/disman-minutes-96jun.txt for just
one example.

Some of the thornier issues are in the slides for the disman session at
http://www.ietf.org/proceedings/97dec/index.html

There's lots of discussion in the WG archives, starting with the
generic debate about the choice between dedicated MIBs
(like Ping/Traceroute), scripting, and expressions.  Some of the
threads from August / September 1996 give some insight into
the thinking, and Bob Stewart's postings in March 1997 mark
the birth of the expression MIB.

Randy